<template lang='pug'>
BaseDialog(ref='dialog' title='Add Property')
  BaseAnimationGroup.row.justify-content-center(anim="height")
    .col-12(key='type')
      .input-group.input-group-sm.my-1
        .input-group-prepend
          .input-group-text.text-muted(style='min-width: 8rem;') type
        select.form-control.x-type(v-model='type')
          option(value='number' :selected="1") number
          option(value='enum') enum
          option(value='boolean') boolean
          option(value='auto') auto
    .col-12(key='name')
      .input-group.input-group-sm.my-1
        .input-group-prepend
          .input-group-text.text-muted(style='min-width: 8rem;') name
        input.form-control.x-name(type='text' required='1' v-model='name')
    .col-12(key='computed')
      .input-group.input-group-sm.my-1
        .input-group-prepend
          .input-group-text.text-muted(style='min-width: 8rem;') computed
        .form-control.justify-content-center.d-flex
          BaseToggle.x-computed(:value='computed' :inEdit='true' @edit='computed = $event')
    template(v-if='type === "number"')
      .col-12(key='numberMinMax')
        .input-group.input-group-sm.my-1
          .input-group-prepend
            .input-group-text.text-muted(style='min-width: 8rem;') min/max
          input.form-control.x-min(type='number' step='1' v-model='min')
          input.form-control.x-max(type='number' step='1' v-model='max')
      .col-12(key='numberInitial')
        .input-group.input-group-sm.my-1
          .input-group-prepend
            .input-group-text.text-muted(style='min-width: 8rem;') initial
          input.form-control.x-initial(ref='initial' type='number' step='1')
    template(v-else-if='type === "enum"')
      .col-12(key='enumValues')
        PropertyEnumValuesEdit.my-1(ref='enumValues' value='"";""'
          :inEdit='true' @edit='enumValues = $event')
      .col-12(key='enumInitial')
        .input-group.input-group-sm.my-1
          .input-group-prepend
            .input-group-text.text-muted(style='min-width: 8rem;') initial
          select.form-control.x-initial(ref='initial')
            option(:value='undefined') not set
            option(:value='value' v-for='value in enumValues') {{ value || "&lt;empty&gt;" }}
    template(v-else-if='type === "boolean"')
      .col-12(key='boolInitial')
        .input-group.input-group-sm.my-1
          .input-group-prepend
            .input-group-text.text-muted(style='min-width: 8rem;') initial
          .form-control.justify-content-center.d-flex
            BaseToggle.x-initial(ref='initial' :inEdit='true' :value='false')
    template(v-else-if='type === "auto"')
      .col-12(key='autoMinMax')
        .input-group.input-group-sm.my-1
          .input-group-prepend
            .input-group-text.text-muted(style='min-width: 8rem;') min/max
          input.form-control.x-min(type='number' step='1' v-model='min')
          input.form-control.x-max(type='number' step='1' v-model='max')
      .col-12(key='autoInitial')
        .input-group.input-group-sm.my-1
          .input-group-prepend
            .input-group-text.text-muted(style='min-width: 8rem;') initial
          input.form-control.x-name(ref='initial' type='text' required='1')
  template(v-slot:footer='d')
    button.btn.btn-secondary(@click='d.resolve(false)') Cancel
    button.btn.btn-primary(:disabled='!name' @click='d.resolve(true)') Ok
</template>
<script src='./CreatePropertyDialog.vue.js' />
